                                {SKELET-L.PAS}

PROGRAM Spielskelett_L;
  {Der Computer ist Spielleiter}

  USES
    Crt, UDialog1, UNimSp_L;

  VAR
    name              : ARRAY[tSpieler] OF string;
    AnfangsSituation,
    EndSituation      : tSituation;

  PROCEDURE Vorbereitungen;
    {setzt generelle Anfangsbedingungen}

    PROCEDURE Namenseingabe;
      {Eingabe der Spielernamen}
      BEGIN
        write('Name des ersten Spielers?  ');
        readln(name[erster]);
        write('Name des zweiten Spielers? ');
        readln(name[zweiter]);
        name[keiner] := 'Keiner';
      END; {of Namenseingabe}

    BEGIN {Vorbereitungen}
      Namenseingabe;
      Voreinstellungen;
      randomize {Zufallszahlengenerator}
    END; {of Vorbereitungen}

  PROCEDURE Spielbeschreibung;
    {nennt auf Wunsch die Spielregeln}
    BEGIN
      clrScr;
      gotoXY(20, 5); write(spielname);
      writeln; writeln
    END; {of Spielbeschreibung}

  PROCEDURE Startangaben (VAR situation: tSituation);
    {legt Startposition und anziehenden Spieler fest}
    VAR
      antwort : char;
    BEGIN
      WITH situation DO BEGIN
        Anfang(pos);
        writeln; write('Wer soll beginnen, ', name[erster]);
        write(' oder ', name[zweiter], '?(1/2) ');
        lies_Zeichen(antwort, ['1', '2']); writeln;
        CASE antwort OF
          '1' : am_Zug := erster;
          '2' : am_Zug := zweiter
        END {case}
      END {of with}
    END; {of Startangaben}

  PROCEDURE Partie (start: tSituation; VAR ziel: tSituation);
    {das eigentliche Spielgeschehen, die Zugfolge}

    VAR
      situation, neuSituation : tSituation;

    PROCEDURE Uebergang (alt: tSituation; VAR neu: tSituation);
      {aus alter Situation und Zug wird neue Situation}
      VAR
        zug : tZug;

      PROCEDURE spieler_zieht (sit: tSituation; VAR zug: tZug);
        {der Zug des Spielers wird eingelesen und geprft}
        VAR
          korrekt : boolean;
        BEGIN
          textColor(lightred); writeln;
          writeln(name[sit.am_Zug], ' ist am Zug.');
          REPEAT
            Eingabe(zug);
            korrekt := zulaessig(sit.pos, zug);
            IF NOT korrekt THEN
              writeln(warnton, 'Der Zug ist nicht zulssig!')
          UNTIL korrekt
        END; {of Spieler zieht}

      BEGIN {bergang}
        spieler_zieht(alt, zug);
        ausgefuehrt(alt, zug, neu)
      END; {of bergang}

    BEGIN {Partie}
      situation := start;
      REPEAT
        Ausgabe(situation);
        Uebergang(situation, neuSituation);
        situation := neuSituation
      UNTIL Ende(situation);
      ziel := situation
    END; {of Partie}

  PROCEDURE Endinformation (sit: tSituation);
    {informiert ber den Ausgang der Partie}
    BEGIN
      Ausgabe(sit);
      writeln; textColor(yellow);
      writeln(name[sit.am_Zug], ' hat gewonnen.')
    END; {of Endinformation}

  FUNCTION Schluss: boolean;
    {prft, ob die Spieler genug haben}
    VAR
      antwort : char;
    BEGIN
      textColor(lightgreen); writeln;
      write('Noch eine Partie ?(j/n) ');
      lies_Zeichen(antwort, ['j', 'J', 'n', 'N']);
      Schluss := antwort IN ['n', 'N']
    END; {of Schlu}

  PROCEDURE Spielende;
    {der Computer empfiehlt sich}
    BEGIN
      writeln; writeln; textColor(brown);
      write('Ende des Spiels ', spielname, '. '); readln
    END; {of Spielende}

  BEGIN {Hauptprogramm}
    Spielbeschreibung;
    Vorbereitungen;
    REPEAT
      Startangaben(AnfangsSituation);
      Partie(AnfangsSituation, EndSituation);
      Endinformation(EndSituation)
    UNTIL Schluss;
    Spielende
  END.
