                                {SKELET-G.PAS}

PROGRAM Spielskelett_G;
  {Der Computer ist Spielgegner}

  USES
    Crt, UDialog1, UNimSp_G;

  VAR
    AnfangsSituation, EndSituation : tSituation;

  PROCEDURE Spielbeschreibung;
    {nennt auf Wunsch die Spielregeln}
    BEGIN
      clrScr;
      gotoXY(20, 5); write(spielname);
      writeln; writeln
    END; {of Spielbeschreibung}

  PROCEDURE Vorbereitungen;
    {setzt generelle Anfangsbedingungen}
    BEGIN
      Voreinstellungen;
      randomize {Zufallszahlengenerator}
    END; {of Vorbereitungen}

  PROCEDURE Startangaben (VAR situation: tSituation);
    {legt Startposition und anziehenden Spieler fest}
    VAR
      antwort : char;
    BEGIN
      WITH situation DO BEGIN
        Anfang(pos); writeln;
        write('Wer soll beginnen, Mensch oder Computer ?(m/c) ');
        lies_Zeichen(antwort, ['m', 'c']); writeln;
        CASE antwort OF
          'm' : am_Zug := mensch;
          'c' : am_Zug := computer
        END {case}
      END {of with}
    END; {of Startangaben}

  PROCEDURE Partie (start: tSituation; VAR ziel: tSituation);
    {das eigentliche Spielgeschehen, die Zugfolge}

    VAR
      situation, neuSituation : tSituation;

    PROCEDURE Uebergang (alt: tSituation; VAR neu: tSituation);
      {aus alter Situation und Zug wird neue Situation}
      VAR
        zug: tZug;

      PROCEDURE spieler_zieht (sit: tSituation; VAR zug: tZug);
        {der Zug des Spielers wird eingelesen und geprft}
        VAR
          korrekt : boolean;
        BEGIN
          textColor(lightred); writeln;
          writeln('Sie sind am Zug!');
          REPEAT
            Eingabe(zug);
            korrekt := zulaessig(sit.pos, zug);
            IF NOT korrekt THEN
              writeln(warnton, 'Der Zug ist nicht zulssig!')
          UNTIL korrekt
        END; {of Spieler zieht}

      PROCEDURE computer_zieht (sit: tSituation; VAR zug: tZug);
        {der Zug des Computers wird ermittelt}
        BEGIN
          textColor(lightred); writeln;
          write('Ich bin am Zug ... ');
          Strategie(sit, zug); Meldung(zug)
        END; {of Computer zieht}

      BEGIN {bergang}
        CASE alt.am_Zug OF
          mensch   : spieler_zieht(alt, zug);
          computer : computer_zieht(alt, zug)
        END; {of case}
        ausgefuehrt(alt, zug, neu)
      END; {of bergang}

    BEGIN {Partie}
      situation := start;
      REPEAT
        Ausgabe(situation);
        Uebergang(situation, neuSituation);
        situation := neuSituation
      UNTIL Ende(situation);
      ziel := situation
    END; {of Partie}

  PROCEDURE Endinformation (sit: tSituation);
    {informiert ber den Ausgang der Partie}
    BEGIN
      Ausgabe(sit);
      writeln; textColor(yellow);
      CASE sit.am_Zug OF
        mensch   : writeln('Glckwunsch, Sie haben gewonnen!');
        computer : writeln('Ich habe gewonnen.');
        keiner   : writeln('Die Partie endete unentschieden.')
      END {of case}
    END; {of Endinformation}

  FUNCTION Schluss: boolean;
    {prft, ob die Spieler genug haben}
    VAR
      antwort : char;
    BEGIN
      textColor(lightgreen); writeln;
      write('Noch eine Partie ?(j/n) ');
      lies_Zeichen(antwort, ['j', 'J', 'n', 'N']);
      Schluss := antwort IN ['n', 'N']
    END; {of Schlu}

  PROCEDURE Spielende;
    {der Computer empfiehlt sich}
    BEGIN
      writeln; writeln; textColor(brown);
      write('Ende des Spiels ', spielname, '. '); readln
    END; {of Spielende}

  BEGIN {Hauptprogramm}
    Spielbeschreibung;
    Vorbereitungen;
    REPEAT
      Startangaben(AnfangsSituation);
      Partie(AnfangsSituation, EndSituation);
      Endinformation(EndSituation)
    UNTIL Schluss;
    Spielende
  END.
